// Code generated by mockery v2.53.0. DO NOT EDIT.

package db

import (
	context "context"

	mock "github.com/stretchr/testify/mock"
	models "gitlab.com/infor-cloud/martian-cloud/phobos/phobos-api/internal/models"
)

// MockAgents is an autogenerated mock type for the Agents type
type MockAgents struct {
	mock.Mock
}

// CreateAgent provides a mock function with given fields: ctx, agent
func (_m *MockAgents) CreateAgent(ctx context.Context, agent *models.Agent) (*models.Agent, error) {
	ret := _m.Called(ctx, agent)

	if len(ret) == 0 {
		panic("no return value specified for CreateAgent")
	}

	var r0 *models.Agent
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, *models.Agent) (*models.Agent, error)); ok {
		return rf(ctx, agent)
	}
	if rf, ok := ret.Get(0).(func(context.Context, *models.Agent) *models.Agent); ok {
		r0 = rf(ctx, agent)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*models.Agent)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, *models.Agent) error); ok {
		r1 = rf(ctx, agent)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// DeleteAgent provides a mock function with given fields: ctx, agent
func (_m *MockAgents) DeleteAgent(ctx context.Context, agent *models.Agent) error {
	ret := _m.Called(ctx, agent)

	if len(ret) == 0 {
		panic("no return value specified for DeleteAgent")
	}

	var r0 error
	if rf, ok := ret.Get(0).(func(context.Context, *models.Agent) error); ok {
		r0 = rf(ctx, agent)
	} else {
		r0 = ret.Error(0)
	}

	return r0
}

// GetAgentByID provides a mock function with given fields: ctx, id
func (_m *MockAgents) GetAgentByID(ctx context.Context, id string) (*models.Agent, error) {
	ret := _m.Called(ctx, id)

	if len(ret) == 0 {
		panic("no return value specified for GetAgentByID")
	}

	var r0 *models.Agent
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, string) (*models.Agent, error)); ok {
		return rf(ctx, id)
	}
	if rf, ok := ret.Get(0).(func(context.Context, string) *models.Agent); ok {
		r0 = rf(ctx, id)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*models.Agent)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, string) error); ok {
		r1 = rf(ctx, id)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// GetAgentByPRN provides a mock function with given fields: ctx, prn
func (_m *MockAgents) GetAgentByPRN(ctx context.Context, prn string) (*models.Agent, error) {
	ret := _m.Called(ctx, prn)

	if len(ret) == 0 {
		panic("no return value specified for GetAgentByPRN")
	}

	var r0 *models.Agent
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, string) (*models.Agent, error)); ok {
		return rf(ctx, prn)
	}
	if rf, ok := ret.Get(0).(func(context.Context, string) *models.Agent); ok {
		r0 = rf(ctx, prn)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*models.Agent)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, string) error); ok {
		r1 = rf(ctx, prn)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// GetAgents provides a mock function with given fields: ctx, input
func (_m *MockAgents) GetAgents(ctx context.Context, input *GetAgentsInput) (*AgentsResult, error) {
	ret := _m.Called(ctx, input)

	if len(ret) == 0 {
		panic("no return value specified for GetAgents")
	}

	var r0 *AgentsResult
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, *GetAgentsInput) (*AgentsResult, error)); ok {
		return rf(ctx, input)
	}
	if rf, ok := ret.Get(0).(func(context.Context, *GetAgentsInput) *AgentsResult); ok {
		r0 = rf(ctx, input)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*AgentsResult)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, *GetAgentsInput) error); ok {
		r1 = rf(ctx, input)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// UpdateAgent provides a mock function with given fields: ctx, agent
func (_m *MockAgents) UpdateAgent(ctx context.Context, agent *models.Agent) (*models.Agent, error) {
	ret := _m.Called(ctx, agent)

	if len(ret) == 0 {
		panic("no return value specified for UpdateAgent")
	}

	var r0 *models.Agent
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, *models.Agent) (*models.Agent, error)); ok {
		return rf(ctx, agent)
	}
	if rf, ok := ret.Get(0).(func(context.Context, *models.Agent) *models.Agent); ok {
		r0 = rf(ctx, agent)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*models.Agent)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, *models.Agent) error); ok {
		r1 = rf(ctx, agent)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// NewMockAgents creates a new instance of MockAgents. It also registers a testing interface on the mock and a cleanup function to assert the mocks expectations.
// The first argument is typically a *testing.T value.
func NewMockAgents(t interface {
	mock.TestingT
	Cleanup(func())
}) *MockAgents {
	mock := &MockAgents{}
	mock.Mock.Test(t)

	t.Cleanup(func() { mock.AssertExpectations(t) })

	return mock
}
